/***************************************************************************
                           routelvi.h
                           version 0.5.3 $Revision: 1.7 $
                           -------------------------------
    copyright            : (C) 2007-2008 by Guido Scholz
    email                : guido.scholz@bayernline.de
    last modified        : $Date: 2008-11-23 21:05:25 $
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
   this is the headerfile for routelvi.cpp
 ***************************************************************************/

#ifndef ROUTELVI_H
#define ROUTELVI_H

#include <QTreeWidget>
#include <QPixmap>


/*Indices for route list columns*/
enum RouteLviData {rlviId = 0, rlviName, rlviFromSig, rlviEntryTrack,
    rlviToSig, rlviExitTrack, rlviType, rlviTrain, rlviState,
    rlviLength, rlviLimit};

// forward declaration
class Route;

class RouteLVI: public QTreeWidgetItem
{

private:
    Route* route;
    QPixmap pLocked;
    QPixmap pUnlocked;
    QPixmap pWfLock;
    QPixmap pWfUnlock;
    bool operator<(const QTreeWidgetItem&) const;

public:
    RouteLVI(QTreeWidget *parent=0, Route* rt = 0);
    int getRouteState();
    unsigned int getRouteId();
    unsigned int getRouteTrain();
    unsigned int getRouteLength();
    unsigned int getRouteSpeedLimit();
    unsigned int getRouteEntryTrack();
    unsigned int getRouteExitTrack();
    Route* getRoute();
    void setRoute(Route*);
    void updateRouteStatePixmap();
    void updateRouteData();
};
#endif // ROUTELVI_H

